#open"syntaxe_commune";;

type expr_miniml =
   MLApp of expr_miniml * expr_miniml
 | MLFun of string * expr_miniml
 | MLVar of string
 | MLCst of constante
 | MLIf of expr_miniml * expr_miniml * expr_miniml
 | MLSet of string * expr_miniml
 | MLLetIn of (string * expr_miniml) list * expr_miniml
 | MLLetRecIn of (string * expr_miniml) list * expr_miniml
 | MLSeq of expr_miniml list * expr_miniml
 | MLPrim of primitive
;;

type phrase_miniml =
   MLExpr of expr_miniml
 | MLLet of (string * expr_miniml) list
 | MLLetRec of (string * expr_miniml) list
;;

type programme_miniml == phrase_miniml list
;;
